#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

size_t fwrite(void *ptr,size_t size,size_t nmemb,FILE *f)
{
  size_t total=size*nmemb;
  char *p=ptr;
  long result;

  if (!f) {
    errno = EBADF;
    return (0);
  }
  if ((f->flags&(_WRITEABLE|_READ|_ERR|_EOF))!=_WRITEABLE) {
    errno = EBADF;
    return (0);
  }
  f->flags |= _WRITE;
  if (!f->bufsize)
    f->bufsize = (f->flags&_UNBUF) ? 1 : BUFSIZ;
  if (!f->base) {
    if (!(f->base = malloc(f->bufsize+1))) {
      errno = ENOMEM;
      return (0);
    }
    f->base++;
    f->pointer = f->base;
    f->count = f->bufsize;
  }
  if (f->count==0)
    f->count = f->bufsize;
  if(total < f->count) {
    memcpy(f->pointer,p,total);
    f->pointer += total;
    f->count -= total;
    return (nmemb);
  }
  if (fflush(f))
    return (0);
  if ((result = _write(f->filehandle,p,total)) == EOF) {
    f->flags|=_ERR;
    return (0);
  }
  return (result/size);
}
